#ifndef ADC_H
#define ADC_H

#include	<avr/io.h>

uint16_t	voltage;
uint8_t		adc_state;

#define adc_ready() !bit_is_set(ADCSRA,ADSC)

void	adc_init( void )
{
	ADCSRA	= _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1);	// 8Mhz - prescaler - 64
	ADMUX	= _BV(REFS1) | _BV(REFS0);		// internal voltage reference 2.56V with 100nF external capacitor on AREF
}

void	adc_start( void )
{
	if (!adc_state) {
		ADCSRA |= _BV(ADSC);
		adc_state = 1;
	}
}

uint8_t	adc_read( void )
{
	if (( adc_ready() ) && ( adc_state )) {
		uint32_t adcval = ADCW;
		// Rx=510 (GND), Ry=4K7 (VCC) (Rx+Ry)/Rx =10.22  Measures up to 26.15V
		
		adcval *= 256;
		voltage *= 7;
		voltage += adcval/100;
		voltage /= 8;
		
		adc_state = 0;
		return 1;
	}
	return 0;
}


#endif // ADC_H
