#ifndef CONFIG_PORTS_H
#define CONFIG_PORTS_H


#if defined(_FOCUSER_) && defined(_FILTERWHEEL_)

//	#define LCD_WIDTH 20 -   makefile

	#define RS			  PC7        //    RS () =8
	#define EN			  PC6        //    E () =9


	#define keyPinFocuserPrev PC0 //   
	#define keyPinFocuserNext PC1
	#define keyPinFilterPrev  PC2
	#define keyPinFilterNext  PC3
	
#if (LCD_WIDTH > 16)
	#define keyPinCommand     PC2
	#define keyPinFocuserCorr PC1
	#define keyPinSpeed       PC0
	#define keyPinCorrection  PC3
#else
	#define keyPinCommand     PC0
	#define keyPinFocuserCorr PC1
	#define keyPinSpeed       PC2
	#define keyPinCorrection  PC3
#endif

	#define keyInMenus    PC4
	#define keyInActions  PC5

	#define portKeyLCD	  PORTC
	#define portKeyLCD_D  DDRC
	#define iportKeyRead  PINC

#ifdef LAZY
	#define portMotor   PORTD
	#define portMotorD	DDRD
	#define PHASE_A		  PD4  //     
	#define PHASE_B		  PD5
	#define PHASE_C		  PD6
	#define PHASE_D		  PD7
#else
	#define portMotor   PORTA
	#define portMotorD	DDRA
	#define PHASE_A		  PA0  //     
	#define PHASE_B		  PA1
	#define PHASE_C		  PA2
	#define PHASE_D		  PA3
#endif

	#define motorPowerOut PB4
	#define portPowerOut  PORTB
	#define portPowerD    DDRB

	#define portFMotor		PORTA
	#define portFMotorD		DDRA
	#define F_PHASE_A		  PA7  //    
	#define F_PHASE_B		  PA6
	#define F_PHASE_C		  PA5
	#define F_PHASE_D		  PA4

	#define SENSORHOME		PB1
	#define SENSORFILTER	PB0  
	#define iportSensors   PINB


	#define SCL			PB3   
	#define SDA			PB2   

	#define i2PortOut   PORTB
	#define i2PortIn    PINB
	#define i2PortD     DDRB

	#define termN_cloud 2
	#define termN_sensor 100

/*******************************************/
/*        1-wire Hardware connection       */
/*******************************************/

	#define OW_PIN  PB2
	#define OW_IN   PINB
	#define OW_OUT  PORTB
	#define OW_DDR  DDRB



#else // WF_AND_FOCUSER

//	#define LCD_WIDTH 16 -   makefile

	//#define E unsigned __attribute__ ((section(".eeprom"))) //=7
	#define RS			PB5        //    RS () =8
	#define EN			PB4        //    E () =9

	#define keyPinFocuserPrev PB0 //   
	#define keyPinFocuserNext PB1
	#define keyPinFilterPrev  PB2
	#define keyPinFilterNext  PB3

	#define keyPinCommand     PB0
	#define keyPinFocuserCorr PB1
	#define keyPinCorrection  PB2
	#define keyPinSpeed       PB3

	#define keyInMenus        PD2
	#define keyInActions      PD3

	#define portKeyLCD   PORTB
	#define portKeyLCD_D  DDRB
	#define iportKeyRead PIND

	#define motorPowerOut PD4
	#define portPowerOut  PORTD
	#define portPowerD    DDRD

	#define portMotorD	  DDRC
	#define portMotor     PORTC
	#define PHASE_A  	  PC5  //   
	#define PHASE_B		  PC4
	#define PHASE_C		  PC3
	#define PHASE_D		  PC2

	#define portFMotor		PORTC
	#define portFMotorD		DDRC
	#define F_PHASE_A		PC2  //    
	#define F_PHASE_B		PC3
	#define F_PHASE_C		PC4
	#define F_PHASE_D		PC5


	#define SENSORHOME		PC1
	#define SENSORFILTER	PC0 
	#define iportSensors   PINC

	#define SCL			PC1
	#define SDA			PC0
	#define i2PortOut   PORTC
	#define i2PortIn    PINC
	#define i2PortD     DDRC

	#define termN_cloud 1
	#define termN_sensor 100

/*******************************************/
/*        1-wire Hardware connection       */
/*******************************************/

#define OW_PIN  PC0
#define OW_IN   PINC
#define OW_OUT  PORTC
#define OW_DDR  DDRC



#endif // WF_AND_FOCUSER


#define	SMB_PORT	i2PortOut
#define	SMB_DDR		i2PortD
#define	SMB_PIN		i2PortIn
#define	SMB_SDA_PIN	SDA
#define	SMB_SCL_PIN	SCL


#endif // CONFIG_PORTS_H
