unsigned char EEPROM_READ(unsigned int uiAddress)
{
	/*     */
	while(EECR & (1<<EEWE));
	/*    */
	EEAR = uiAddress;
	/*       EERE */
	EECR |= (1<<EERE);
	/*      */
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		asm("cli");

		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		asm("sei");
	}
	//clear_adres_eeprom();
}

void EEPROM_write_int(unsigned int uiAddress, int ucData)
{
	unsigned char buff;
	buff= ucData & 0x00FF;
	EEPROM_write(uiAddress, buff);
	buff= (ucData>>8) & 0x00FF;
	EEPROM_write(uiAddress+1, buff);
	delay_loop_mks(10000);
}

int EEPROM_READ_INT (unsigned int uiAddress)
{
	unsigned int buff;
	buff = (EEPROM_READ(uiAddress+1))*256;
	buff = buff | EEPROM_READ(uiAddress);
	return buff;
}

void EEPROM_WRITE_STRING(const char* str, unsigned int length, unsigned int uiAddress)
{
  unsigned int i = 0;
  for(; i < length; i++)
  {
    EEPROM_write(uiAddress+i, str[i]);
  }
}

void EEPROM_READ_STRING(char* str, unsigned int length, unsigned int uiAddress)
{
  unsigned int i = 0;
  for(; i < length; i++)
  {
    str[i] = EEPROM_READ(uiAddress+i);
  }
}
