unsigned char termometer_error;

             

#define i2cdelay    20
#define i2cdelay2   40
#define i2cdelay1_3 5
#define i2cdelay4_3 35



#define I2DA   _BV(SDA)
#define I2LDA ~_BV(SDA)
#define I2CL   _BV(SCL)
#define I2LCL ~_BV(SCL)


/*
void i2start(void)             
{ 
	i2PortD &= ~_BV(SDA) & ~_BV(SCL);     
	i2PortOut &= (~_BV(SDA)) & (~_BV(SCL)); 
	_delay_loop_1(i2cdelay);
	i2PortD |= _BV(SDA);            
	_delay_loop_1(i2cdelay);      
	i2PortD |= _BV(SCL);            
	_delay_loop_1(i2cdelay);                 
	return;            
}                         
//-----------     i2c---------- =23
void i2write(unsigned char bw) 
{ 
	unsigned char k, m;        
	for (k=0; k < 8; k++)         
	{ 
		m = 0x01 & (bw >> (7-k));      
		if (m == 0) 
			i2PortD |= _BV(SDA);    
		else 
			i2PortD &= ~_BV(SDA);    
		_delay_loop_1(i2cdelay);               
		i2PortD &= ~_BV(SCL); 		_delay_loop_1(i2cdelay * 2);
		i2PortD |= _BV(SCL); 		_delay_loop_1(i2cdelay);
	}               
	return;            
}
*/

        
//-------------    I2C------------- =12
void i2start(void)             
{ 
	i2PortOut |= I2DA | I2CL; 
	i2PortD |=  I2DA | I2CL; 
	_delay_loop_1(i2cdelay);

	i2PortOut &= I2LDA;            
	_delay_loop_1(i2cdelay);      
	i2PortOut &= I2LCL;            
	_delay_loop_1(i2cdelay1_3);                 
	return;            
}                         
//-----------     i2c---------- =23
void i2write(unsigned char bw) 
{ 
	unsigned char k, m;        
	for (k=0; k < 8; k++)         
	{ 
		m = 0x01 & (bw >> (7-k));      
		if (m == 0) 
			i2PortOut &= I2LDA;    
		else 
			i2PortOut |= I2DA;

		if(!k)
			i2PortD |=  I2DA | I2CL; 

								_delay_loop_1(i2cdelay4_3);               
		i2PortOut |= I2CL; 		_delay_loop_1(i2cdelay2);
		i2PortOut &= I2LCL; 	_delay_loop_1(i2cdelay1_3);
	}               
	return;            
}                        

//---------   --------- =36
unsigned char i2ack(void)        
{ 
//	i2PortOut |= I2DA;
	i2PortD &= I2LDA; 			    _delay_loop_1(i2cdelay4_3);    
	i2PortOut |= I2CL;				_delay_loop_1(i2cdelay2);
	if (bit_is_set(i2PortIn,SDA)) 
		termometer_error = 255;      
	i2PortOut &= I2LCL; 			_delay_loop_1(i2cdelay1_3);  

	return termometer_error;
}     

#define i2ack_ret(n) if( i2ack() ) { i2stop(); return n; }

//--------     I2C-------- =45
void i2stop(void)               
{
	i2PortOut &= I2LDA & I2LCL;
	i2PortD |= I2DA | I2CL;			_delay_loop_1(i2cdelay4_3);   
	i2PortOut |= I2CL;				_delay_loop_1(i2cdelay);
	i2PortOut |= I2DA;				_delay_loop_1(i2cdelay);
	i2PortD &= I2LDA & I2LCL;		_delay_loop_2(i2cdelay * 10);
	return;            
}                          

/*-------   ----------=53*/
void i2mack(void)      
{ 
	i2PortOut &= I2LDA;
	i2PortD |= I2DA | I2CL;     _delay_loop_1(i2cdelay); 
	i2PortOut |= I2CL;			_delay_loop_1(i2cdelay2);
	i2PortOut &= I2LCL;			_delay_loop_1(i2cdelay);
	return;         
}                      

/*-------   ------=60*/
void i2nack(void)         
{ 
	unsigned char y;                 
	
	i2PortD &= I2LDA;			_delay_loop_1(i2cdelay);
	i2PortOut |= I2CL;			_delay_loop_1(i2cdelay);
	for (y = 10; y > 0; y--)       
	{ 
		_delay_loop_1(i2cdelay);
		if( bit_is_set(i2PortIn, SDA) )
			break; 
	} 
	
	i2PortOut &= I2LCL;			_delay_loop_1(i2cdelay);
	return;         
}                       

 /*-------     i2c--------=73*/
unsigned char i2read(void)   
{ 
	unsigned char k, s, d=0,sdab=0;
	
	i2PortD &= I2LDA;
	for (s = k = 0; k < 8; k++)    
	{ 
									_delay_loop_1(i2cdelay);
		i2PortOut |= I2CL; 			_delay_loop_1(i2cdelay4_3);
		if (bit_is_clear(i2PortIn,SDA))
			sdab=0;
		if (bit_is_set(i2PortIn,SDA)) 
			sdab=1;
		s = sdab << (7 - k);  
		d = d | s;					_delay_loop_1(i2cdelay1_3);
		i2PortOut &= I2LCL;			_delay_loop_1(i2cdelay);
	}                   
	
	return (d);      
}                       

char checkI2Port(void)
{
	i2PortOut |= I2CL | I2DA;
	i2PortD &= I2LDA & I2LCL;
	_delay_loop_1(i2cdelay);

	termometer_error = ~(i2PortIn | (I2LCL & I2LDA));

	if( termometer_error )
	{
		i2start(); 
		i2write(0xff);
		i2ack();
		i2stop();

		termometer_error = ~(i2PortIn | (I2LCL & I2LDA));
	}

	return termometer_error;
// 	if( termometer_error )
// 		return termometer_error;
}

unsigned char  temperature_start(unsigned char termometr)
{
	i2start(); 
	i2write(0x90 | (termometr * 2)); //  
	i2ack(); 

	i2write(0x51); // 	Initiates temperature conversions. If the
// 		performed. In continuous mode (1SHOT
// 		Stop Convert T command is issued.

	i2ack(); 
	i2stop();

	return termometer_error;
}

unsigned char set_temperature_mode_ds1631 (unsigned char termometr, unsigned char continuos)
{
	i2start(); 
	i2write(0x90 | (termometr * 2)); //   
	i2ack();     
	i2write(0xAC);	  // Reads or writes the 1-byte configuration register.
	i2ack(); 
	i2write( continuos ? 0x0C : 0x0D);  
	i2ack();
	i2stop();

	return termometer_error;
}

unsigned char get_temperature_ready_flag(unsigned char termometr)
{
	i2start(); 
	i2write(0x90 | (termometr * 2)); //   
	i2ack_ret(0);
	i2write(0xAC);	  // Reads or writes the 1-byte configuration register.
	i2ack_ret(0);
	_delay_loop_1(100);

	i2start(); 
	i2write( 0x91 | (termometr * 2) );  //  
	i2ack_ret(0);
	char fl = i2read(); 
	i2nack(); 
	i2stop();

	return fl;
}

  
int temperature_read(unsigned char termometr)
{
	int tmpr = 0;
	uint8_t t1, t2;
	
	i2start(); 
	i2write(0x90 | (termometr * 2)); //  
	i2ack_ret(0x8000);
	
	i2write(0xAA);  // Reads last converted temperature value from the 2-byte temperature register.
	i2ack_ret(0x8000);
	
	i2start(); 
	i2write( 0x91 | (termometr * 2) );  //  
	i2ack_ret(0x8000);
	t1 = i2read(); 
	i2mack();
    t2 = i2read(); 
	i2nack(); 
	i2stop();

	int16_t tt = ((t1<<8) | t2);

	int32_t tt32 = tt;
	tt32 *= 100;
	tt32 /= 256;
	tmpr = tt32;

//	tmpr = (float)tt * (100.f / 256.f);

	if( termometer_error )
		tmpr = 0x8000;

	return tmpr;
}

// int readTemperature(unsigned char termometer)
// {
// 	termometer_error = 0;
// 
// 	set_temperature_mode_ds1631(termometer);
// 	temperature_start_ds1631(termometer);
// 
// 	int tempr = temperature_read(termometer);
// 
// 	return tempr;
// }


//*********************************************************************************************
//									CALCULATION PEC PACKET	
//*********************************************************************************************
//Name:			PEC_calculation
//Function:		Calculates the PEC of received bytes
//Parameters:	unsigned char pec[]			
//Return:		pec[0]-this byte contains calculated crc value
//Comments: 	Refer to "System Managment BUS(SMBus) specification Version 2.0" and
//				AN "SMBus comunication with MLX90614"
//*********************************************************************************************
unsigned char PEC_calculation(unsigned char pec[])
{
	unsigned char 	crc[6];
	unsigned char	BitPosition=47;
	unsigned char	shift;
	unsigned char	i;
	unsigned char	j;
	unsigned char	temp;

	do{
		crc[5]=0;				/* Load CRC value 0x000000000107 */
		crc[4]=0;
		crc[3]=0;
		crc[2]=0;
		crc[1]=0x01;
		crc[0]=0x07;
		BitPosition=47;			/* Set maximum bit position at 47 */
		shift=0;

		//Find first 1 in the transmited message
		i=5;					/* Set highest index */
		j=0;
		while((pec[i]&(0x80>>j))==0 && i>0){
			BitPosition--;
			if(j<7){
				j++;
			}
			else{
				j=0x00;
				i--;
			}
		}/*End of while */

		shift=BitPosition-8;	/*Get shift value for crc value*/


		//Shift crc value 
		while(shift){
			for(i=5; i<0xFF; i--){
				if((crc[i-1]&0x80) && (i>0)){
					temp=1;
				}
				else{
					temp=0;
				}
				crc[i]<<=1;
				crc[i]+=temp;
			}/*End of for*/
			shift--;
		}/*End of while*/


		//Exclusive OR between pec and crc		
		for(i=0; i<=5; i++){
			pec[i] ^=crc[i];
		}/*End of for*/
	}while(BitPosition>8);/*End of do-while*/

	return pec[0];
}/*End of PEC_calculation*/


#define SA		0x00	// Slave address
#define DEFAULT_SA	0x5A	// Default Slave address
#define RAM_Access	0x00	// RAM access command
#define EEPROM_Access	0x20	// EEPROM access command
#define RAM_Ta		0x06	// Ta address in the RAM
#define RAM_Tobj1	0x07	// To1 address in the RAM
#define RAM_Tobj2	0x08	// To2 address in the AM


uint16_t MLX_memread2(uint8_t SlaveAddress,uint8_t command)
{
	termometer_error = 0;
	
	i2start();
	i2write(SlaveAddress);
	i2ack_ret(0);

	i2write(command);
	i2ack_ret(0);

	i2start(); 
	i2write(SlaveAddress);
	i2ack_ret(0);
	
	uint8_t DataL = i2read(); 
	i2mack();
	uint8_t DataH = i2read(); 
	i2mack();
	uint8_t PEC	= i2read(); 
	i2nack(); 
	i2stop();

	uint8_t		arr[6];			// Buffer for the sent bytes

	arr[5]=SlaveAddress;		//
	arr[4]=command;				//
	arr[3]=SlaveAddress;		//Load array arr 
	arr[2]=DataL;				//
	arr[1]=DataH;				//
	arr[0]=0;					//
	uint8_t PecReg = PEC_calculation(arr);//Calculate CRC

	if( PecReg != PEC )
	{
		termometer_error = 255;
		return 0;
	}

	uint16_t	data = DataL | (DataH << 8);
	return data;							
}

#define		MLX_calctemp(x)		x*2-27315
#define		MLX_read_Tobj1_2()	MLX_memread2(DEFAULT_SA<<1,RAM_Access|RAM_Tobj1)
#define		MLX_read_Ta_2()		MLX_memread2(DEFAULT_SA<<1,RAM_Access|RAM_Ta)
