
#define LCD_TIME (CPUMHZ * 5)

#define pause _delay_loop_2

//-----------    --------------- =22
void lcd_com(unsigned char p)       //"p" -   =23
{ 
	portKeyLCD &= ~_BV(RS);                       // RS=0 
	portKeyLCD |= _BV(EN);                        // EN=1 
	portKeyLCD &= 0xF0; portKeyLCD |= ((p >>4)&0x0F);    // 
	pause(LCD_TIME);                 //  EN
	portKeyLCD &= ~_BV(EN);   //EN=0,     
	pause(LCD_TIME);                 //  EN
	portKeyLCD|= _BV(EN);                        // EN=1
	portKeyLCD &= 0xF0; portKeyLCD |= (p & 0x0F);      // 
	pause(LCD_TIME);                 //  EN =32
	portKeyLCD &= ~_BV(EN);   //EN=0,      =33
	pause(5*LCD_TIME);          //    =34
}

//-----------    ---------------- =36
void lcd_dat(unsigned char p)        //"p" -   =37
{
	portKeyLCD |= _BV(RS) | _BV(EN);       // RS=1, EN=1 =38
	portKeyLCD &= 0xF0; portKeyLCD |= ((p >>4)&0x0F); //  =39
	pause(LCD_TIME);                 //  EN =40
	portKeyLCD &= ~_BV(EN);   //EN=0,      =41
	pause(LCD_TIME);                 //  EN =42
	portKeyLCD |= _BV(EN);                        // EN=1 =43
	portKeyLCD &= 0xF0; portKeyLCD |= (p & 0x0F);      //  =31
	pause(LCD_TIME);                 //  EN =45
	portKeyLCD &= ~_BV(EN);   //EN=0,      =46
	pause(5*LCD_TIME);          //    =47
} 

//---------------------------------------------------------------
#define lcd_xy(X,Y)     lcd_com(0x80+0x40*(Y)+(X))
//------------
void lcd_clean_line(char Y)
{
	lcd_xy(0, Y);
	for( int8_t i = LCD_WIDTH; i > 0; --i ) lcd_dat(' ');
}

void lcd_clean_fast(void)
{
	lcd_clean_line(0);
	lcd_clean_line(1);
}

#define lcd_cursor_off()        lcd_com(0x0C)

//------------  -----------------
void lcd_init(void)       // 4 ,  
{ 
	lcd_com(0x33); pause(500*LCD_TIME);           //
	lcd_com(0x32); lcd_com(0x28);        //4 , 2 
	lcd_com(0x08);             //  
	lcd_com(0x01); pause(1000*LCD_TIME);     // 
	lcd_com(0x06);                  //  
	lcd_com(0x0D);    // ,  

	lcd_cursor_off();
	lcd_clean_fast();
} 


//---------------------------------------------------------------
// void lcd_clean (void)
// {
// 	lcd_com(0x01);
// 	delay_loop_mks(100000L);
// }

//----------------------------------------------------------------
//void lcd_home (void)
//{
//lcd_com(0x02);
//}
//----------------------------------------------------------------
//----------------------------------------------------------------
//void lcd_cursor_square (void)
//{
//lcd_com(0x0D);
//}

//----------------------------------------------------------------
//void lcd_cursor_line (void)
//{
//lcd_com(0x0E);
//}
//-----------------------------------------------------------------


void lcd_write_uint(unsigned int data, char count)
{
	int digit = 1;
	for( ; count > 1; --count )
		digit *= 10;
	
	while(digit)
	{
		unsigned int b = (data/digit) % 10;
		lcd_dat(b + '0');
		digit /= 10;
	}
}

void lcd_write_int(int data, char count)
{
	if(data >= 0) 
		lcd_dat('+'); 
	else 
	{
		lcd_dat('-');
		data=-data;
	}
	lcd_write_uint(data, count);
}

void lcd_write_char_hex(unsigned char ch)
{
	unsigned char ch2 = ch / 16;
	ch = ch & 0x0f;
	if( ch2 < 10 ) 
		lcd_dat(ch2 + '0');
	else
		lcd_dat(ch2 + 'A' - 10);
	if( ch < 10 ) 
		lcd_dat(ch + '0');
	else
		lcd_dat(ch + 'A' - 10);
}

void lcd_write_int_hex(uint16_t num)
{
	char* ch = (char*)&num;

	lcd_write_char_hex(ch[1]);
	lcd_write_char_hex(ch[0]);
}

void lcd_write_string(char t2[])
{
	unsigned char b = 0;
	while(t2[b] != 0 && b < 32)
	{
		lcd_dat(t2[b]);
		b++;
	}
}

void lcd_write_string_n(char t2[], unsigned char count)
{
	unsigned char b = 0;
	while( t2[b] !=0 && count > 0 )
	{
		lcd_dat(t2[b]);
		count--;
		b++;
	}
	for(; count > 0; count--)
		lcd_dat(' ');
}

void lcd_write_eepromStr(uint16_t addr)
{
	unsigned char c=EEPROM_READ(addr);
	while(c)
	{
		lcd_dat(c);
		addr++;
		c=EEPROM_READ(addr);
	}
}


//===========================================================================
